﻿;
;    MiniM
;
;    PureBasic example how to call MiniM Server Connect
;

XIncludeFile "MiniMSC.pb"

Procedure HandleMNMError( Connect.i)
  Define.MINIMSTR err
  MNMGetLastError( Connect, @err)
  PrintN( "MiniM error: " + MiniMSTRToString( @err))
EndProcedure

  OpenConsole()

  PrintN( "PureBasic example how to call MiniM Server Connect")
  
  If minimsc_LoadDLL() = 0
    PrintN("Filed to load minimsc library.")
    End
  EndIf
  
  Define.i Connect
  
  Connect = MNMCreateConnect("localhost", 5000, "user")
  
  Define.l ret
  
  ret = MNMConnectOpen(Connect)
  
  If ret = 0
    HandleMNMError( Connect)
    Goto ExitDestroy
  EndIf
  
  Define.MINIMSTR value
  Define.MINIMSTR expr
  
  ; read version info
  StringToMiniMSTR("$zversion",@expr)
  ret = MNMRead( Connect, @expr, @value)
  If ret=0
    HandleMNMError( Connect)
    Goto ExitClose
  EndIf
  
  ; print result
  PrintN("MiniM version: " + MiniMSTRToString(@value))
  
  ; execute commands
  StringToMiniMSTR( "s a=123,b=456", @expr)
  ret = MNMExecute(Connect, @expr)
  If ret=0
    HandleMNMError( Connect)
    Goto ExitClose
  EndIf
  
  ; read 2 variables as list
  StringToMiniMSTR("$lb(a,b)",@expr)
  ret = MNMRead( Connect, @expr, @value)
  If ret=0
    HandleMNMError( Connect)
    Goto ExitClose
  EndIf
  
  ; get list length
  Define.l ListLength
  ListLength = MNMListLength(@value)
  PrintN("List length: " + Str(ListLength))
  
  ; unpack List Structure
  Define.MINIMSTR element
  
  MNMListGet(@value, 1, @element)
  ; show value
  PrintN("First list item is: " + MiniMSTRToString(@element))
  
  MNMListGet(@value, 2, @element)
  ; show value
  PrintN("Second list item is: " + MiniMSTRToString(@element))
  
ExitClose:  
  MNMConnectClose(Connect)
  
ExitDestroy:  
  MNMDestroyConnect(Connect)
  
  Print( "Example finished, press Enter.")
  Input()
  
  CloseConsole()
End
; IDE Options = PureBasic 5.50 (Linux - x86)
; CursorPosition = 18
; FirstLine = 5
; Folding = -
; EnableXP