;
;    MiniM
;
;    PureBasic example how to call MiniM Server Connect
;

XIncludeFile "MiniMSC.pb"

Procedure HandleMNMError( Connect.i)
  Define.MINIMSTR err
  MNMGetLastError( Connect, @err)
  PrintN( "MiniM error: " + MiniMSTRToString( @err))
EndProcedure

Procedure OutputProc(Connect.i, *value.MINIMSTR)
  Print(MiniMSTRToString(*value))
EndProcedure

  OpenConsole()

  PrintN( "PureBasic example how to call MiniM Server Connect")
  
  If minimsc_LoadDLL() = 0
    PrintN("Filed to load minimsc library.")
    End
  EndIf
  
  Define.i Connect
  
  Connect = MNMCreateConnect("localhost", 5000, "user")
  
  Define.l ret
  
  ret = MNMConnectOpen(Connect)
  
  If ret = 0
    HandleMNMError( Connect)
    Goto ExitDestroy
  EndIf
  
  PrintN("MiniM database list:")
  
  ; set output notifier function
  MNMSetOutput(Connect,@OutputProc())
  Define.MINIMSTR commands
  ; MUMPS code to read database list from $v("db",15)
  StringToMiniMSTR("s List=$v(" + #DQUOTE$ + "db" + 
                   #DQUOTE$ + ",15) f i=1:1:$l(List," + 
                   #DQUOTE$ + "*" + #DQUOTE$ + 
                   ") w $p(List," + #DQUOTE$ + "*" + 
                   #DQUOTE$ + ",i),!", @commands)
  ; execute code to get database list
  MNMExecuteOutput( Connect, @commands)
  
ExitClose:  
  MNMConnectClose(Connect)
  
ExitDestroy:  
  MNMDestroyConnect(Connect)
  
  Print( "Example finished, press Enter.")
  Input()
  
  CloseConsole()
End

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 26
; FirstLine = 1
; Folding = -
; EnableXP