;
;    MiniM
;
;    PureBasic example how to call MiniM Server Connect
;

XIncludeFile "MiniMSC.pb"

Procedure HandleMNMError( Connect.i)
  Define.MINIMSTR err
  MNMGetLastError( Connect, @err)
  PrintN( "MiniM error: " + MiniMSTRToString( @err))
EndProcedure

Procedure GroupReadProc(Connect.i, *Value.MINIMSTR)
  ; unpack name and date and print
  Define.MINIMSTR Name
  Define.MINIMSTR Date
  MNMListGet( *Value, 1, @Name);
  MNMListGet( *Value, 2, @Date);
  PrintN("Routine name: " + MiniMSTRToString(@Name) + 
         ", date change: " + MiniMStrToString(@Date))
EndProcedure

  OpenConsole()

  PrintN( "PureBasic example how to call MiniM Server Connect")
  
  If minimsc_LoadDLL() = 0
    PrintN("Filed to load minimsc library.")
    End
  EndIf
  
  Define.i Connect
  
  Connect = MNMCreateConnect("localhost", 5000, "%sys")
  
  Define.l ret
  
  ret = MNMConnectOpen(Connect)
  
  If ret = 0
    HandleMNMError( Connect)
    Goto ExitDestroy
  EndIf
  
  MNMSetGroupRead(Connect,@GroupReadProc())
  
  Define.MINIMSTR Command
  StringToMiniMSTR("s i=" + #DQUOTE$ + #DQUOTE$ + 
                   " f  s i=$o(^ROUTINE(i)) q:i=" + 
                   #DQUOTE$ + #DQUOTE$ + 
                   "  d wo^%srv($lb(i,$zd($g(^ROUTINE(i,0)),3)))", @Command)
  MNMExecute(Connect, @Command)
  
ExitClose:  
  MNMConnectClose(Connect)
  
ExitDestroy:  
  MNMDestroyConnect(Connect)
  
  Print( "Example finished, press Enter.")
  Input()
  
  CloseConsole()
End
 
; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 35
; FirstLine = 9
; Folding = -
; EnableXP