;
;    MiniM
;
;    PureBasic example how to call MiniM Server Connect
;

XIncludeFile "MiniMSC.pb"

Procedure HandleMNMError( Connect.i)
  Define.MINIMSTR err
  MNMGetLastError( Connect, @err)
  PrintN( "MiniM error: " + MiniMSTRToString( @err))
EndProcedure

Procedure CallbackHandler(Connect.i, *Command.MINIMSTR, *Answer.MINIMSTR)
  ; in this context we can call MiniM
  ; in example 5 we ignore Command value
  Define.MINIMSTR Expression
  Define.MINIMSTR Value
  StringToMiniMSTR("$zt($p($h," + #DQUOTE$ + "," + #DQUOTE$ + ",2))",@Expression)
  MNMRead( Connect, @Expression, @Value);
  ; compose callback answer
  StringToMiniMSTR(" time: " + MiniMStrToString(@Value), *Answer)
  ; trace execution order
  PrintN("Client on command " + #DQUOTE$ + MiniMStrToString(*Command) + #DQUOTE$ + 
         " return: " + MiniMStrToString(*Answer))
EndProcedure

  OpenConsole()

  PrintN( "PureBasic example how to call MiniM Server Connect")
  
  If minimsc_LoadDLL() = 0
    PrintN("Filed to load minimsc library.")
    End
  EndIf
  
  Define.i Connect
  
  Connect = MNMCreateConnect("localhost", 5000, "user")
  
  Define.l ret
  
  ret = MNMConnectOpen(Connect)
  
  If ret = 0
    HandleMNMError( Connect)
    Goto ExitDestroy
  EndIf
  
  ; set callback handler
  MNMSetCallback( Connect, @CallbackHandler());
  
  ; call routine which call client back
  Define.MINIMSTR Expression
  StringToMiniMSTR("$$callback^example5()", @Expression)
  Define.MINIMSTR Value
  MNMRead( Connect, @Expression, @Value)
  
  ; trace execution order
  PrintN("Server return: " + MiniMSTRToString(@Value))
  
ExitClose:  
  MNMConnectClose(Connect)
  
ExitDestroy:  
  MNMDestroyConnect(Connect)
  
  Print( "Example finished, press Enter.")
  Input()
  
  CloseConsole()
End
 
; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 25
; Folding = -
; EnableXP