﻿;
;
;    MiniM
;
;    MiniM Server Connect
;    DLL Interface
;
;    Copyright (C) Eugene Karataev
;    All rights reserved
;
;

#MINIMSTR_MAX = 32 * 1024

Structure MINIMSTR Align 1
  len.w
  Data.b[#MINIMSTR_MAX]
EndStructure

Procedure.s MiniMSTRToString(*mnms.MINIMSTR)
  ProcedureReturn PeekS( @*mnms\Data, *mnms\len, #PB_Ascii)
EndProcedure

Procedure StringToMiniMSTR(str.s, *mnms.MINIMSTR)
  len.l = Len(str)
  *mnms\len = len
  PokeS(@*mnms\Data, str, len, #PB_Ascii)
EndProcedure

; prototypes of callback functions
Prototype    mnmoutputproc(ConnectionID.i, *value.MINIMSTR)
Prototype    mnmgroupreadproc(ConnectionID.i, *value.MINIMSTR)
Prototype    mnmcallbackproc(ConnectionID.i, *command.MINIMSTR, *answer.MINIMSTR)

; prototypes of callable functions
Prototype.l  MNMConnectClose(ConnectionID.i)
Prototype.l  MNMConnectOpen(ConnectionID.i)
Prototype.i  MNMCreateConnect(host.p-ascii, port.l, database.p-ascii)
Prototype    MNMDestroyConnect( ConnectionID.i)
Prototype.l  MNMExecute(ConnectionID.i, *expr.MINIMSTR)
Prototype.l  MNMExecuteOutput(ConnectionID.i, *expr.MINIMSTR)
Prototype    MNMGetLastError(ConnectionID.i, *err.MINIMSTR)
Prototype.l  MNMKill(ConnectionID.i, *varname.MINIMSTR)
Prototype.l  MNMListGet(*value.MINIMSTR, pos.l, *element.MINIMSTR)
Prototype.l  MNMListLength(*value.MINIMSTR)
Prototype.l  MNMListSet(*value.MINIMSTR, pos.l, *element.MINIMSTR)
Prototype.l  MNMRead(ConnectionID.i, *expr.MINIMSTR, *value.MINIMSTR)
Prototype    MNMSetCallback(ConnectionID.i, *pCallbackProc.mnmcallbackproc)
Prototype    MNMSetGroupRead(ConnectionID.i, *pGroupReadProc.mnmgroupreadproc)
Prototype    MNMSetOutput(ConnectionID.i, *pOutProc.mnmoutputproc)
Prototype.l  MNMText(*Source.MINIMSTR, *Target.MINIMSTR)
Prototype.l  MNMWrite(ConnectionID.i, *VarName.MINIMSTR, *VarValue.MINIMSTR)

Global MNMConnectClose.MNMConnectClose
Global MNMConnectOpen.MNMConnectOpen
Global MNMCreateConnect.MNMCreateConnect
Global MNMDestroyConnect.MNMDestroyConnect
Global MNMExecute.MNMExecute
Global MNMExecuteOutput.MNMExecuteOutput
Global MNMGetLastError.MNMGetLastError
Global MNMKill.MNMKill
Global MNMListGet.MNMListGet
Global MNMListLength.MNMListLength
Global MNMListSet.MNMListSet
Global MNMRead.MNMRead
Global MNMSetCallback.MNMSetCallback
Global MNMSetGroupRead.MNMSetGroupRead
Global MNMSetOutput.MNMSetOutput
Global MNMText.MNMText
Global MNMWrite.MNMWrite

Procedure.i minimsc_LoadDLL()
  Protected hDLL.i
  
  Define.s filename
  
  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows  
      filename = "minimsc.dll"
    CompilerCase #PB_OS_Linux
      filename = "libminimsc.so"
    CompilerCase #PB_OS_MacOS
      filename = "libminimsc.dylib"
  CompilerEndSelect

  hDLL = OpenLibrary(#PB_Any, filename)
  If hDLL <> 0
    MNMConnectClose = GetFunction(hDLL, "MNMConnectClose")
    MNMConnectOpen = GetFunction(hDLL, "MNMConnectOpen")
    MNMCreateConnect = GetFunction(hDLL, "MNMCreateConnect")
    MNMDestroyConnect = GetFunction(hDLL, "MNMDestroyConnect")
    MNMExecute = GetFunction(hDLL, "MNMExecute")
    MNMExecuteOutput = GetFunction(hDLL, "MNMExecuteOutput")
    MNMGetLastError = GetFunction(hDLL, "MNMGetLastError")
    MNMKill = GetFunction(hDLL, "MNMKill")
    MNMListGet = GetFunction(hDLL, "MNMListGet")
    MNMListLength = GetFunction(hDLL, "MNMListLength")
    MNMListSet = GetFunction(hDLL, "MNMListSet")
    MNMRead = GetFunction(hDLL, "MNMRead")
    MNMSetCallback = GetFunction(hDLL, "MNMSetCallback")
    MNMSetGroupRead = GetFunction(hDLL, "MNMSetGroupRead")
    MNMSetOutput = GetFunction(hDLL, "MNMSetOutput")
    MNMText = GetFunction(hDLL, "MNMText")
    MNMWrite = GetFunction(hDLL, "MNMWrite")

    ProcedureReturn hDLL
  EndIf

  ProcedureReturn #False
EndProcedure

; IDE Options = PureBasic 5.50 (Linux - x86)
; CursorPosition = 71
; FirstLine = 60
; Folding = -
; EnableXP