/*
 
    MiniM
    C# example how to call MiniM Server Connect
 
*/

using System;
using System.Collections.Generic;
using System.Text;
using MiniMExamples;

namespace Example1
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine( "C# example how to call MiniM Server Connect");

            MiniMSC Connect = new MiniMSC();

            // see default connection parameters in class MiniMSC
            // and change one here if need

            Console.WriteLine( "Do create connect");

            Connect.CreateConnect();

            Console.WriteLine("Do open connect");

            if (!Connect.ConnectOpen())
            {
                Console.WriteLine("MiniM error: {0}", Connect.GetLastError());
                return;
            }

            // read version info
            MiniMSC.MINIMSTR sexpr = new MiniMSC.MINIMSTR();
            MiniMSC.MINIMSTR svalue = new MiniMSC.MINIMSTR();
            MiniMSC.StringToMINIMSTR( "$zversion", ref sexpr);
            if ( Connect.Read(ref sexpr, ref svalue) == 0)
            {
                Console.WriteLine("MiniM error: {0}", Connect.GetLastError());
                return;
            }
            Console.WriteLine("MiniM version: {0}", MiniMSC.MINIMSTRToString(ref svalue));

            // execute commands
            MiniMSC.StringToMINIMSTR("s a=123,b=456", ref sexpr);
            if (Connect.Execute(ref sexpr) == 0)
            {
                Console.WriteLine("MiniM error: {0}", Connect.GetLastError());
                return;
            }

            // read 2 variables as list
            MiniMSC.StringToMINIMSTR("$lb(a,b)", ref sexpr);
            if (Connect.Read(ref sexpr, ref svalue) == 0)
            {
                Console.WriteLine("MiniM error: {0}", Connect.GetLastError());
                return;
            }

            // get list length
            Console.WriteLine("List length: {0}", MiniMSC.MNMListLength( ref svalue));

            // unpack list structure
            MiniMSC.MINIMSTR element = new MiniMSC.MINIMSTR();

            MiniMSC.MNMListGet( ref svalue, 1, ref element);

            // show value
            Console.WriteLine("First list item is: {0}",
                MiniMSC.MINIMSTRToString(ref element));

            MiniMSC.MNMListGet(ref svalue, 2, ref element);

            // show value
            Console.WriteLine("Second list item is: {0}",
                MiniMSC.MINIMSTRToString(ref element));

            Console.WriteLine( "Example finished, press any key.");
            Console.ReadKey( false);

            // disconnect from MiniM
            Connect.ConnectClose();

            // remove connect
            Connect.DestroyConnect();

            return;
        }
    }
}
