/*
 
    MiniM
    C# example how to call MiniM Server Connect
 
*/

using System;
using System.Collections.Generic;
using System.Text;
using MiniMExamples;

namespace Example2
{
    class Program
    {
        public static void OutputStr(IntPtr MNMConnect, ref MiniMSC.MINIMSTR Value)
        {
            Console.Write( MiniMSC.MINIMSTRToString( ref Value));
            return;
        }

        static void Main(string[] args)
        {
            Console.WriteLine("C# example how to call MiniM Server Connect");

            MiniMSC Connect = new MiniMSC();

            // see default connection parameters in class MiniMSC
            // and change one here if need

            Connect.CreateConnect();
            if (!Connect.ConnectOpen())
            {
                Console.WriteLine("MiniM error: {0}", Connect.GetLastError());
                return;
            }

            // set output notifier function
            Connect.SetOutput( new MiniMSC.OutputProc( OutputStr));

            Console.WriteLine("MiniM database list:");

            MiniMSC.MINIMSTR Commands = new MiniMSC.MINIMSTR();
            MiniMSC.StringToMINIMSTR(
                "s list=$v(\"db\",15) f i=1:1:$l(list,\"*\") w $p(list,\"*\",i),!", 
                ref Commands);

            // execute code to get database list
            Connect.ExecuteOutput( ref Commands);

            Console.WriteLine( "Example finished, press any key.");
            Console.ReadKey( false);

            // disconnect from MiniM
            Connect.ConnectClose();

            // remove connect
            Connect.DestroyConnect();

            return;
        }
    }
}
