using System;
using System.Collections.Generic;
using System.Text;
using MiniMExamples;

namespace Example4
{
    class Program
    {
        public static void GroupReadHandler(IntPtr MNMConnect, ref MiniMSC.MINIMSTR Value)
        {
            MiniMSC.MINIMSTR Name = new MiniMSC.MINIMSTR();
            MiniMSC.MINIMSTR Date = new MiniMSC.MINIMSTR();
            MiniMSC.MNMListGet( ref Value, 1, ref Name);
            MiniMSC.MNMListGet( ref Value, 2, ref Date);
            Console.WriteLine("Routine name: {0}, date change: {1}",
                MiniMSC.MINIMSTRToString(ref Name),
                MiniMSC.MINIMSTRToString(ref Date));
            return;
        }
        
        static void Main(string[] args)
        {
            Console.WriteLine("C# example how to call MiniM Server Connect");

            MiniMSC Connect = new MiniMSC();

            // see default connection parameters in class MiniMSC
            // and change one here if need

            Connect.CreateConnect();
            if (!Connect.ConnectOpen())
            {
                Console.WriteLine("MiniM error: {0}", Connect.GetLastError());
                return;
            }

            // get routine's list as $lb( name , date )

            Connect.SetGroupRead(new MiniMSC.GroupReadProc(GroupReadHandler));
            MiniMSC.MINIMSTR Commands = new MiniMSC.MINIMSTR();

            MiniMSC.StringToMINIMSTR(
                "s i=\"\" f  s i=$o(^ROUTINE(i)) q:i=\"\"  d wo^%srv($lb(i,$zd($g(^ROUTINE(i,0)),3)))",
                ref Commands);

            Connect.Execute(ref Commands);

            Connect.SetGroupRead(null);

            Console.WriteLine( "Example finished, press any key.");
            Console.ReadKey( false);

            // disconnect from MiniM
            Connect.ConnectClose();

            // remove connect
            Connect.DestroyConnect();

            return;
        }
    }
}
