using System;
using System.Collections.Generic;
using System.Text;
using MiniMExamples;

namespace Example5
{
    class Example5
    {
        // examples use simple data transfer and we need Connect 
        // to use inside CallbackHandler
        public static MiniMSC Connect = null;

        public static void CallbackHandler(IntPtr MNMConnect, ref MiniMSC.MINIMSTR Command,
                    ref MiniMSC.MINIMSTR Answer)
        {
            MiniMSC.MINIMSTR Expression = new MiniMSC.MINIMSTR();
            MiniMSC.StringToMINIMSTR("$zt($p($h,\",\",2))", ref Expression);
            MiniMSC.MINIMSTR Value = new MiniMSC.MINIMSTR();
            Connect.Read(ref Expression, ref Value);

            // compose callback answer
            MiniMSC.StringToMINIMSTR( " time: " + 
                MiniMSC.MINIMSTRToString( ref Value), ref Answer);

            // trace execution order
            Console.WriteLine("Client on command \"{0}\"", 
                MiniMSC.MINIMSTRToString(ref Command));
        }
        
        static void Main(string[] args)
        {
            Console.WriteLine("C# example how to call MiniM Server Connect");

            Connect = new MiniMSC();

            // see default connection parameters in class MiniMSC
            // and change one here if need

            Connect.CreateConnect();
            if (!Connect.ConnectOpen())
            {
                Console.WriteLine("MiniM error: {0}", Connect.GetLastError());
                return;
            }

            // set callback handler
            Connect.SetCallback( new MiniMSC.CallbackProc(CallbackHandler));

            MiniMSC.MINIMSTR Expression = new MiniMSC.MINIMSTR();
            MiniMSC.StringToMINIMSTR( "$$callback^example5()", ref Expression);
            MiniMSC.MINIMSTR Value = new MiniMSC.MINIMSTR();
            Connect.Read(ref Expression, ref Value);

            // trace execution order
            Console.WriteLine("Server return: {0}", MiniMSC.MINIMSTRToString( ref Value));

            Connect.SetCallback(null);

            Console.WriteLine( "Example finished, press any key.");
            Console.ReadKey( false);

            // disconnect from MiniM
            Connect.ConnectClose();

            // remove connect
            Connect.DestroyConnect();

            return;
        }
    }
}
