/*

    MiniM

    C++ example to call MiniM Server Connect

*/

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>

#include "minimsc.h"

// this library should be created using your compiler from minimsc.dll
#pragma link "minimsc.lib"

void HandleMNMError( HMNMConnect Connect)
{
  MINIMSTR err;
  MNMGetLastError( Connect, &err);
  printf( "MiniM error:\n%.*s\n", err.len, err.data);
  return;
};

void __stdcall OutputProc( HMNMConnect pConnect, MINIMSTR* Value )
{
  printf( "%.*s", Value->len, Value->data);
  return;
};

int main(int argc, char* argv[])
{
  printf( "C++ example how to call MiniM Server Connect\n");

  // create connect to MiniM
  HMNMConnect Connect = MNMCreateConnect( "localhost", 5000, "user");

  // activate connection
  int ret = MNMConnectOpen( Connect);
  if( !ret)
  {
    HandleMNMError( Connect);
    return 0;
  }

  // set output notifier function
  MNMSetOutput( Connect, OutputProc);

  printf( "MiniM database list:\n");

  MINIMSTR Commands;
  Commands.len = sprintf( Commands.data, "%s",
    "s list=$v(\"db\",15) f i=1:1:$l(list,\"*\") w $p(list,\"*\",i),!");

  // execute code to get database list
  MNMExecuteOutput( Connect, &Commands);

  printf( "Example finished, press Enter.");
  fgetc( stdin);

  // disconnect from MiniM
  MNMConnectClose( Connect);

  // remove connect
  MNMDestroyConnect( Connect);

  return 0;
};
 