program example5;

{$AppType CONSOLE}

uses
  Windows,
  SysUtils,
  Forms,
  minimscint;

var
  Connect: HMNMConnect;
  ret: Integer;
  Expression: MINIMSTR;
  Value: MINIMSTR;

function ToString( Str: PMINIMSTR): String;
var
  p: PChar;
begin
  p := @(Str^.data);
  SetString( Result, p, Str^.len);
end;

procedure ToMNMString( const Source: String; Dest: PMINIMSTR );
var
  len: Integer;
  p: Pchar;
begin
  len := Length( Source);
  Dest^.len := len;
  p := @(Dest^.data);
  CopyMemory( p, PChar( Source), len);
end;

procedure HandleMNMError( Connect: HMNMConnect);
var
  err: MINIMSTR;
begin
  MNMGetLastError( Connect, @err);
  WriteLn( 'MiniM error:');
  WriteLn( ToString( @err));
end;

// callback handler
procedure CallbackHandler( Connect: HMNMConnect; Command: PMINIMSTR;
  Answer: PMINIMSTR); stdcall;
var
  Expression: MINIMSTR;
  Value: MINIMSTR;  
begin

  // in this contex we can call MiniM
  // in example 5 we ignore Command value
  ToMNMString( '$zt($p($h,",",2))', @Expression);
  MNMRead( Connect, @Expression, @Value);

  // compose callback answer
  ToMNMString( ' time: ' + ToString( @Value), Answer);

  // trace execution order
  WriteLn( 'Client on command "' + ToString( Command) +
    '" return: ' + ToString( Answer));

end;

begin

  WriteLn( 'Delphi example how to call MiniM Server Connect');

  // create connect to MiniM
  Connect := MNMCreateConnect( 'localhost', 5000, 'user');

  // activate connection
  ret := MNMConnectOpen( Connect);
  if ret = 0 then
  begin
    HandleMNMError( Connect);
    Exit;
  end;

  // set callback handler
  MNMSetCallback( Connect, CallbackHandler);

  // call routine which call client back
  ToMNMString( '$$callback^example5()', @Expression);
  MNMRead( Connect, @Expression, @Value);

  // trace execution order
  WriteLn( 'Server return: ' + ToString( @Value));

  MNMSetCallback( Connect, nil);

  WriteLn( 'Example finished, press enter...');
  ReadLn;

  // disconnect from MiniM
  MNMConnectClose( Connect);

  // remove connect
  MNMDestroyConnect( Connect);
  
end.
