/*

    MiniM
    
    Java example how to call MiniM Server Connect

*/

class example1
{
	public static void main(String[] args)
	{
		try
		{

		System.out.println("Java example how to call MiniM Server Connect");

		// create connect to MiniM
		// setup need ANSI <-> Unicode code page conversion
		// "Cp1251" is Windows Cyrillic code page, it is example only
		minimscj Connect = new minimscj( "localhost", 5000, "user", "Cp1251");

		// open connect to MiniM
		Connect.ConnectOpen();

		// read version info
		String Value = Connect.Read( "$zversion");

		// print result
		System.out.println( Value);

		// execute commands
		Connect.Execute( "s a=123,b=456");

		// read 2 variables as list
		String list = Connect.Read( "$lb(a,b)");

		// get list length
		int ListLength = Connect.ListLength( list);
		System.out.println( "List length: " + ListLength);

		// unpack list structure
		Value = Connect.ListGet( list, 1);

		// show value
		System.out.println( "First list item is: " + Value);

		Value = Connect.ListGet( list, 2);

		// show value
		System.out.println( "Second list item is: " + Value);

		// set 3 element
		list = Connect.ListSet( list, 3, "789");

		// write list
		Connect.Write( "list", list);

		Value = Connect.Read( "$lg(list,3)");

		// show value
		System.out.println( "Third list item is: " + Value);

		// disconnect from MiniM
		Connect.ConnectClose();

		// remove connect
		Connect.DestroyConnect();

		}
		catch(Throwable e)
		{
			e.printStackTrace();
		}
		return;
	};
};