/*

    MiniM
    
    Java example how to call MiniM Server Connect

*/

// implement MiniM Server Connect callback functionality
class CallbackExample implements minimscj.Callback
{
	public String Callback( minimscj Connect, String Command)
	{
		try
		{
			String Value = Connect.Read( "$zt($p($h,\",\",2))");

			// compose callback answer
			String ret = " time: " + Value;

			// trace execution order
			System.out.println( "Client on command \"" + Command + "\"  return: " +
				ret);
		
			return ret;
		}
		catch(Throwable e)
		{
			e.printStackTrace();
			return "";
		}
	};
};

class example5
{
	public static void main(String[] args)
	{
		try
		{

		System.out.println("Java example how to call MiniM Server Connect");

		// create connect to MiniM
		// setup need ANSI <-> Unicode code page conversion
		// "Cp1251" is Windows Cyrillic code page, it is example only
		minimscj Connect = new minimscj( "localhost", 5000, "user", "Cp1251");

		// open connect to MiniM
		Connect.ConnectOpen();

		CallbackExample cb = new CallbackExample();
		Connect.SetCallback( cb);

		String Value = Connect.Read( "$$callback^example5()");
		
		Connect.SetCallback( null);

		// trace execution order
		System.out.println( "Server return: " + Value);

		// disconnect from MiniM
		Connect.ConnectClose();

		// remove connect
		Connect.DestroyConnect();

		}
		catch(Throwable e)
		{
			e.printStackTrace();
		}
		return;
	};
};