/*

    MiniM

    C++ example to call MiniM Server Connect

*/

#include <stdlib.h>
#include <stdio.h>

#include "minimsc.h"

void HandleMNMError( HMNMConnect Connect)
{
  MINIMSTR err;
  MNMGetLastError( Connect, &err);
  printf( "MiniM error:\n%.*s\n", err.len, err.data);
  return;
};

void STDCALL GroupReadHandler( HMNMConnect pConnect, MINIMSTR* Value)
{
  // unpack name and date and print
  MINIMSTR Name;
  MINIMSTR Date;
  MNMListGet( Value, 1, &Name);
  MNMListGet( Value, 2, &Date);
  printf( "Routine name: %.*s, date change: %.*s\n",
    Name.len, Name.data, Date.len, Date.data);
  return;
};

int main(int argc, char* argv[])
{
  printf( "C++ example how to call MiniM Server Connect\n");

  // create connect to MiniM
  HMNMConnect Connect = MNMCreateConnect( (char*)"192.168.121.1", 5000, (char*)"user");

  // activate connection
  int ret = MNMConnectOpen( Connect);
  if( !ret)
  {
    HandleMNMError( Connect);
    return 0;
  }

  // get routine's list as $lb( name , date )

  // set handler for group read event
  MNMSetGroupRead( Connect, GroupReadHandler);
  MINIMSTR Command;

  // command contain code to write group of data from server to client
  // d wo^%srv(...)
  const char* cmd = "s i=\"\" f  s i=$o(^ROUTINE(i)) q:i=\"\"  d wo^%srv($lb(i,$zd($g(^ROUTINE(i,0)),3)))";
  Command.len = sprintf( (char*)Command.data, "%s", cmd);

  MNMExecute( Connect, &Command);

  MNMSetGroupRead( Connect, NULL);

  printf( "Example finished, press Enter.");
  fgetc( stdin);

  // disconnect from MiniM
  MNMConnectClose( Connect);

  // remove connect
  MNMDestroyConnect( Connect);

  return 0;
};
 