program example1;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes
  { you can add units after this }
  , SysUtils, StrUtils, minimscint;

{$IFDEF WINDOWS}{$R example1.rc}{$ENDIF}

var
  Connect: HMNMConnect;
  ret: Integer;
  Expression: MINIMSTR;
  Value: MINIMSTR;
  Element: MINIMSTR;

function ToString( Str: PMINIMSTR): String;
var
  p: PChar;
begin
  p := @(Str^.data);
  SetString( Result, p, Str^.len);
end;

procedure memcpy(dest, source: Pointer; count: Integer);cdecl;
begin
  Move(source^, dest^, count);
end;

procedure ToMNMString( const Source: String; Dest: PMINIMSTR );
var
  len: Integer;
  p: Pchar;
  src: PChar;
begin
  len := Length( Source);
  Dest^.len := len;
  p := PChar( @Dest^.data);
  src := PChar(Source);
  memcpy( p, src, len);
end;

procedure HandleMNMError( Connect: HMNMConnect);
var
  err: MINIMSTR;
begin
  MNMGetLastError( Connect, @err);
  WriteLn( 'MiniM error:');
  WriteLn( ToString( @err));
end;

begin
  WriteLn( 'Lazarus example how to call MiniM Server Connect');

  // create connect to MiniM
  Connect := MNMCreateConnect( '192.168.121.1', 5000, 'user');

  // activate connection
  ret := MNMConnectOpen( Connect);
  if ret = 0 then
  begin
    HandleMNMError( Connect);
    Exit;
  end;

  ToMNMString( '$zversion', @Expression);

  // read version info
  ret := MNMRead( Connect, @Expression, @Value);
  if ret = 0 then
  begin
    HandleMNMError( Connect);
    Exit;
  end;

  // print result
  Write( 'MiniM version: ');
  WriteLn( ToString( @Value));

  // execute commands
  ToMNMString( 's a=123,b=456', @Expression);
  ret := MNMExecute( Connect, @Expression);
  if ret = 0 then
  begin
    HandleMNMError( Connect);
    Exit;
  end;

  ToMNMString( '$lb(a,b)', @Expression);
  ret := MNMRead( Connect, @Expression, @Value);
  if ret = 0 then
  begin
    HandleMNMError( Connect);
    Exit;
  end;

  // get list length
  WriteLn( 'List length: ' + IntToStr( MNMListLength( @Value)));

  // unpack list structure
  MNMListGet( @Value, 1, @Element);

  // show value
  Write( 'First list item is: ');
  WriteLn( ToString( @Element));

  MNMListGet( @Value, 2, @Element);
  Write( 'Second list item is: ');
  WriteLn( ToString( @Element));

  WriteLn( 'Example finished, press enter.');
  ReadLn;

  // disconnect from MiniM
  MNMConnectClose( Connect);

  // remove connect
  MNMDestroyConnect( Connect);

end.

