program example2;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes
  { you can add units after this },
  Sysutils, StrUtils, minimscint;

{$IFDEF WINDOWS}{$R example2.rc}{$ENDIF}

var
  Connect: HMNMConnect;
  ret: Integer;
  Commands: MINIMSTR;
  Expression: MINIMSTR;
  Value: MINIMSTR;

function ToString( Str: PMINIMSTR): String;
var
  p: PChar;
begin
  p := @(Str^.data);
  SetString( Result, p, Str^.len);
end;

procedure memcpy(dest, source: Pointer; count: Integer);cdecl;
begin
  Move(source^, dest^, count);
end;

procedure ToMNMString( const Source: String; Dest: PMINIMSTR );
var
  len: Integer;
  p: Pchar;
  src: PChar;
begin
  len := Length( Source);
  Dest^.len := len;
  p := PChar( @Dest^.data);
  src := PChar(Source);
  memcpy( p, src, len);
end;

procedure HandleMNMError( Connect: HMNMConnect);
var
  err: MINIMSTR;
begin
  MNMGetLastError( Connect, @err);
  WriteLn( 'MiniM error:');
  WriteLn( ToString( @err));
end;

procedure OutputProc( Connect: HMNMConnect; Value: PMINIMSTR); stdcall;
begin
  Write( ToString( Value));
end;

begin
  WriteLn( 'Lazarus example how to call MiniM Server Connect');

  // create connect to MiniM
  Connect := MNMCreateConnect( '192.168.121.1', 5000, 'user');

  // activate connection
  ret := MNMConnectOpen( Connect);
  if ret = 0 then
  begin
    HandleMNMError( Connect);
    Exit;
  end;

  ToMNMString( '$zversion', @Expression);

  // read version info
  ret := MNMRead( Connect, @Expression, @Value);
  if ret = 0 then
  begin
    HandleMNMError( Connect);
    Exit;
  end;

  // print result
  Write( 'MiniM version: ');
  WriteLn( ToString( @Value));

  // set output notifier function
  MNMSetOutput( Connect, @OutputProc);

  WriteLn( 'MiniM database list:');

  ToMNMString( 's list=$v("db",15) f i=1:1:$l(list,"*") w $p(list,"*",i),!',
    @Commands);

  // execute code to get database list
  MNMExecuteOutput( Connect, @Commands);

  WriteLn( 'Example finished, press enter...');
  ReadLn;

  // disconnect from MiniM
  MNMConnectClose( Connect);

  // remove connect
  MNMDestroyConnect( Connect);

end.

