program example4;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes
  { you can add units after this }
  , SysUtils, StrUtils, minimscint;

{$IFDEF WINDOWS}{$R example4.rc}{$ENDIF}

var
  Connect: HMNMConnect;
  ret: Integer;
  Commands: MINIMSTR;

function ToString( Str: PMINIMSTR): String;
var
  p: PChar;
begin
  p := @(Str^.data);
  SetString( Result, p, Str^.len);
end;

procedure memcpy(dest, source: Pointer; count: Integer);cdecl;
begin
  Move(source^, dest^, count);
end;

procedure ToMNMString( const Source: String; Dest: PMINIMSTR );
var
  len: Integer;
  p: Pchar;
  src: PChar;
begin
  len := Length( Source);
  Dest^.len := len;
  p := PChar( @Dest^.data);
  src := PChar(Source);
  memcpy( p, src, len);
end;

procedure HandleMNMError( Connect: HMNMConnect);
var
  err: MINIMSTR;
begin
  MNMGetLastError( Connect, @err);
  WriteLn( 'MiniM error:');
  WriteLn( ToString( @err));
end;

procedure GroupReadHandler( Connect: HMNMConnect; Value: PMINIMSTR); stdcall;
var
  Name: MINIMSTR;
  Date: MINIMSTR;
begin
  // unpack name and date and print
  MNMListGet( Value, 1, @Name);
  MNMListGet( Value, 2, @Date);
  WriteLn( 'Routine name: ' + ToString( @Name) +
    ', date change: ' + ToString( @Date));
end;

begin
  WriteLn( 'Lazarus example how to call MiniM Server Connect');

  // create connect to MiniM
  Connect := MNMCreateConnect( '192.168.121.1', 5000, 'user');

  // activate connection
  ret := MNMConnectOpen( Connect);
  if ret = 0 then
  begin
    HandleMNMError( Connect);
    Exit;
  end;

  // get routine's list as $lb( name , date )
  ToMNMString(
    's i="" f  s i=$o(^ROUTINE(i)) q:i=""  d wo^%srv($lb(i,$zd($g(^ROUTINE(i,0)),3)))',
    @Commands);

  // set handler for group read event
  MNMSetGroupRead( Connect, @GroupReadHandler);
  ret := MNMExecute( Connect, @Commands);
  if ret = 0 then
  begin
    HandleMNMError( Connect);
    Exit;
  end;

  MNMSetGroupRead( Connect, nil);

  WriteLn( 'Example finished, press enter...');
  ReadLn;

  // disconnect from MiniM
  MNMConnectClose( Connect);

  // remove connect
  MNMDestroyConnect( Connect);

end.

