﻿'
' 
' MiniM
' VB.NET example how to call MiniM Server Connect
' 
'
Imports System
Imports System.Collections.Generic
Imports System.Text
' Imports MiniMExamples

Module Example1
    Sub Main()
        Console.WriteLine("VB.NET example how to call MiniM Server Connect")

        Dim Connect As New MiniMSC()

        ' see default connection parameters in class MiniMSC
        ' and change one here if need

        Connect.CreateConnect()
        If Not Connect.ConnectOpen() Then
            Console.WriteLine("MiniM error: {0}", Connect.GetLastError())
            Console.ReadKey()
            Exit Sub
        End If

        ' read version info
        Dim sexpr As New MiniMSC.MINIMSTR()
        Dim svalue As New MiniMSC.MINIMSTR()
        MiniMSC.StringToMINIMSTR("$zversion", sexpr)
        If Connect.Read(sexpr, svalue) = 0 Then
            Console.WriteLine("MiniM error: {0}", Connect.GetLastError())
            Console.ReadKey()
            Exit Sub
        End If
        Console.WriteLine("MiniM version: {0}", MiniMSC.MINIMSTRToString(svalue))

        ' execute commands
        MiniMSC.StringToMINIMSTR("s a=123,b=456", sexpr)
        If Connect.Execute(sexpr) = 0 Then
            Console.WriteLine("MiniM error: {0}", Connect.GetLastError())
            Console.ReadKey()
            Exit Sub
        End If

        ' read 2 variables as list
        MiniMSC.StringToMINIMSTR("$lb(a,b)", sexpr)
        If Connect.Read(sexpr, svalue) = 0 Then
            Console.WriteLine("MiniM error: {0}", Connect.GetLastError())
            Console.ReadKey()
            Exit Sub
        End If

        ' get list length
        Console.WriteLine("List length: {0}", MiniMSC.MNMListLength(svalue))

        ' unpack list structure
        Dim element As New MiniMSC.MINIMSTR()

        MiniMSC.MNMListGet(svalue, 1, element)

        ' show value
        Console.WriteLine("First list item is: {0}", MiniMSC.MINIMSTRToString(element))

        MiniMSC.MNMListGet(svalue, 2, element)

        ' show value
        Console.WriteLine("Second list item is: {0}", MiniMSC.MINIMSTRToString(element))

        ' disconnect from MiniM
        Connect.ConnectClose()

        ' remove connect
        Connect.DestroyConnect()

        Console.ReadKey()
    End Sub
End Module


