﻿'
' 
' MiniM
' VB.NET example how to call MiniM Server Connect
'
'
Imports System
Imports System.Collections.Generic
Imports System.Text
' Imports MiniMExamples

Module Example5
    ' examples use simple data transfer and we need Connect 
    ' to use inside CallbackHandler
    Dim Connect As MiniMSC = Nothing

    Private Sub CallbackHandler(ByVal MNMConnect As IntPtr, ByRef Command As MiniMSC.MINIMSTR, ByRef Answer As MiniMSC.MINIMSTR)
        Dim Expression As New MiniMSC.MINIMSTR()
        MiniMSC.StringToMINIMSTR("$zt($p($h,"","",2))", Expression)
        Dim Value As New MiniMSC.MINIMSTR()
        Connect.Read(Expression, Value)

        ' compose callback answer
        MiniMSC.StringToMINIMSTR(" time: " & MiniMSC.MINIMSTRToString(Value), Answer)

        ' trace execution order
        Console.WriteLine("Client on command ""{0}""", MiniMSC.MINIMSTRToString(Command))
    End Sub

    Sub Main(ByVal args As String())
        Console.WriteLine("VB.NET example how to call MiniM Server Connect")

        Connect = New MiniMSC()

        ' see default connection parameters in class MiniMSC
        ' and change one here if need

        Connect.CreateConnect()
        If Not Connect.ConnectOpen() Then
            Console.WriteLine("MiniM error: {0}", Connect.GetLastError())
            Console.ReadKey()
            Exit Sub
        End If

        ' set callback handler
        Connect.SetCallback(New MiniMSC.CallbackProc(AddressOf CallbackHandler))

        Dim Expression As New MiniMSC.MINIMSTR()
        MiniMSC.StringToMINIMSTR("$$callback^example5()", Expression)
        Dim Value As New MiniMSC.MINIMSTR()
        Connect.Read(Expression, Value)

        ' trace execution order
        Console.WriteLine("Server return: {0}", MiniMSC.MINIMSTRToString(Value))

        Connect.SetCallback(Nothing)

        ' disconnect from MiniM
        Connect.ConnectClose()

        ' remove connect
        Connect.DestroyConnect()

        Console.ReadKey()
    End Sub
End Module
